﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Audio
Imports Microsoft.Xna.Framework.Content
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Xna.Framework.Input
Imports Microsoft.Xna.Framework.GamerServices

Public Class Game
    Inherits Microsoft.Xna.Framework.Game
    'Fields in our game graphic manager etc'
    Dim graphics As GraphicsDeviceManager
    Dim SpriteBatch As SpriteBatch
    Dim rocket As Texture2D

    Dim position As Vector2 = New Vector2(300, 300)
    Dim position2 As Vector2 = New Vector2(700, 500)
    Dim rotation As Single

    Dim dummyTexture As Texture2D

    Dim font As SpriteFont

    Dim scale As Single = 1

    Dim origin As Vector2

    Dim leftTop As Vector2
    Dim rightTop As Vector2
    Dim leftBottom As Vector2
    Dim rightBottom As Vector2

    Dim r As List(Of Vector2)
    Dim r2 As New List(Of Vector2)

    Dim msg As String = "."
    Dim msg2 As String = "."


    Public Sub New()
        graphics = New GraphicsDeviceManager(Me)
        Window.Title = "Test"
        graphics.PreferredBackBufferWidth = 800
        graphics.PreferredBackBufferHeight = 600
    End Sub

    Protected Overrides Sub Initialize()
        MyBase.Initialize()
    End Sub

    Protected Overrides Sub LoadContent()
        ' TODO: use this.Content to load your game content here'
        SpriteBatch = New SpriteBatch(GraphicsDevice)
        rocket = Content.Load(Of Texture2D)("xnb\rocket")
        '
        dummyTexture = New Texture2D(GraphicsDevice, 1, 1)

        Dim c(0) As Color
        c(0) = Color.White
        dummyTexture.SetData(Of Color)(c)

        Primitives2D.dotTexture = dummyTexture

        font = Content.Load(Of SpriteFont)("xnb\myfont")

        origin = New Vector2(rocket.Width / 2, rocket.Height / 2)

        collisiondetection2d.AdditionalRenderTargetForCollision = New RenderTarget2D(graphics.GraphicsDevice, graphics.PreferredBackBufferWidth, graphics.PreferredBackBufferHeight)

        MyBase.LoadContent()

    End Sub
    Protected Overrides Sub UnloadContent()
        MyBase.UnloadContent()
    End Sub

    Private Sub Move(speed_ As Single)
        If speed_ > 0 And position.X + (rocket.Width) >= GraphicsDevice.Viewport.Width Then Exit Sub
        If speed_ > 0 And position.Y + (rocket.Height) >= GraphicsDevice.Viewport.Height Then Exit Sub

        If speed_ > 0 And position.X - (rocket.Width) <= 0 Then Exit Sub
        If speed_ > 0 And position.Y - (rocket.Height) <= 0 Then Exit Sub

        Dim direction As Vector2 = New Vector2(CSng(Math.Cos((rotation))), CSng(Math.Sin((rotation))))
        direction.Normalize()
        position += direction * speed_
    End Sub

    Public Shared Function RotateAround(source As Vector2, target As Vector2, radians As Single) As Vector2
        Dim fromAround As Vector2 = source - target
        Dim postRotationX As Single = CSng(fromAround.X * Math.Cos(radians) - fromAround.Y * Math.Sin(radians))
        Dim postRotationY As Single = CSng(fromAround.X * Math.Sin(radians) + fromAround.Y * Math.Cos(radians))
        Return target + New Vector2(postRotationX, postRotationY)
    End Function
   
    Protected Overrides Sub Update(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        
        If Keyboard.GetState.IsKeyDown(Keys.Left) Then
            If MathHelper.ToDegrees(rotation) >= 0 Then
                rotation -= MathHelper.ToRadians(2)
            End If
            If MathHelper.ToDegrees(rotation) < 0 Then
                rotation = MathHelper.ToRadians(359.99F)
            End If
        End If
        If Keyboard.GetState.IsKeyDown(Keys.Right) Then
            If MathHelper.ToDegrees(rotation) < 360 Then
                rotation += MathHelper.ToRadians(2)
            End If
            If MathHelper.ToDegrees(rotation) > 360 Then
                rotation = MathHelper.ToRadians(0.01F)
            End If
        End If

        If Keyboard.GetState.IsKeyDown(Keys.Up) Then Move(3)
        If Keyboard.GetState.IsKeyDown(Keys.Down) Then Move(-3)
        '

        ' Get all four corners in local space 
        leftTop = New Vector2(position.X - origin.X, position.Y - origin.Y)
        rightTop = New Vector2(position.X + rocket.Width - origin.X, position.Y - origin.Y)
        leftBottom = New Vector2(position.X + rocket.Width - origin.X, position.Y + rocket.Height - origin.Y)
        rightBottom = New Vector2(position.X - origin.X, position.Y + rocket.Height - origin.Y)
        'rotated points
        leftTop = RotateAround(leftTop, New Vector2(position.X, position.Y), rotation)
        rightTop = RotateAround(rightTop, New Vector2(position.X, position.Y), rotation)
        leftBottom = RotateAround(leftBottom, New Vector2(position.X, position.Y), rotation)
        rightBottom = RotateAround(rightBottom, New Vector2(position.X, position.Y), rotation)
        '
        'rectangle around our sprite
        r = New List(Of Vector2)
        r.Add(leftTop)
        r.Add(rightTop)
        r.Add(leftBottom)
        r.Add(rightBottom)
        '

        r2 = New List(Of Vector2)
        r2.Add(New Vector2(position2.X - origin.X, position2.Y - origin.Y))
        r2.Add(New Vector2(position2.X + rocket.Width - origin.X, position2.Y - origin.Y))
        r2.Add(New Vector2(position2.X + rocket.Width - origin.X, position2.Y + rocket.Height - origin.Y))
        r2.Add(New Vector2(position2.X - origin.X, position2.Y + rocket.Height - origin.Y))


        If collisiondetection2d.PerPixelWR(rocket, rocket, position, position2, origin, origin, r, r2, rotation, 0.0F, SpriteBatch) Then
            msg = "ok"
        Else
            msg = "nok"
        End If


        MyBase.Update(gameTime)

    End Sub


    Protected Overrides Sub Draw(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        GraphicsDevice.Clear(Color.CornflowerBlue)
        SpriteBatch.Begin()

        Dim origin As New Vector2(rocket.Width / 2, rocket.Height / 2)
        
        'bounding rectangle
        'Dim bound As Rectangle
        'bound = collisiondetection2d._getBoundingRectangleOfRotatedRectangle(r)

        ''lets draw that bounding rectangle
        'SpriteBatch.Draw(dummyTexture, bound, Color.Black)

        'lets draw the rectangle around our sprite
        'Primitives2D.DrawRectangle(r2, SpriteBatch)
        'Primitives2D.DrawRectangle(r, SpriteBatch)

        SpriteBatch.Draw(rocket, position, Nothing, Color.White, rotation, origin, 1.0F, SpriteEffects.None, 1.0F)
        SpriteBatch.Draw(rocket, position2, Nothing, Color.White, 0.0F, origin, 1.0F, SpriteEffects.None, 1.0F)

        SpriteBatch.DrawString(font, "angle:" & MathHelper.ToDegrees(rotation).ToString, New Vector2(100, 100), Color.White)
        SpriteBatch.DrawString(font, "collision :" & msg, New Vector2(100, 120), Color.White)

        SpriteBatch.End()

        MyBase.Draw(gameTime)
    End Sub
End Class


