﻿
Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Input


    Public NotInheritable Class Primitives2D
        Private Sub New()
        End Sub
        Public Shared Property dotTexture() As Texture2D
            Get
                Return m_dotTexture
            End Get
            Set(value As Texture2D)
                m_dotTexture = Value
            End Set
        End Property
        Private Shared m_dotTexture As Texture2D

        Public Shared Sub DrawLine(start As Vector2, [end] As Vector2, SpriteBatch As SpriteBatch)
            Dim StartToEndVector As Vector2 = [end] - start
            Dim Times As Integer = CInt(StartToEndVector.Length())
            StartToEndVector.Normalize()
            For i As Integer = 0 To Times - 1
            SpriteBatch.Draw(dotTexture, start + i * StartToEndVector, Color.White)
            Next
        End Sub

        Public Shared Sub DrawRectangle(position As Vector2, Width As Integer, Height As Integer, SpriteBatch As SpriteBatch)
        DrawLine(position, New Vector2(position.X + Width, position.Y), SpriteBatch)
        DrawLine(New Vector2(position.X + Width, position.Y), New Vector2(position.X + Width, position.Y + Height), SpriteBatch)
        DrawLine(New Vector2(position.X + Width, position.Y + Height), New Vector2(position.X, position.Y + Height), SpriteBatch)
        DrawLine(New Vector2(position.X, position.Y + Height), position, SpriteBatch)
        End Sub

        Public Shared Sub DrawRectangle(Points As List(Of Vector2), SpriteBatch As SpriteBatch)

            DrawLine(Points(0), Points(1), SpriteBatch)
            DrawLine(Points(1), Points(2), SpriteBatch)
            DrawLine(Points(2), Points(3), SpriteBatch)
            DrawLine(Points(3), Points(0), SpriteBatch)
        End Sub
        Public Shared Sub DrawTriangle(Points As List(Of Vector2), SpriteBatch As SpriteBatch)
            DrawLine(Points(0), Points(1), SpriteBatch)
            DrawLine(Points(1), Points(2), SpriteBatch)
            DrawLine(Points(2), Points(0), SpriteBatch)

        End Sub

        Public Shared Sub DrawCircle(centre As Vector2, radius As Integer, SpriteBatch As SpriteBatch)
            Dim ThetaStep As Single = 0.1F
            Dim Theta As Single = 0

            Dim PointToDraw As Vector2
            While Theta < Math.PI * 2
            PointToDraw = New Vector2(CSng(radius * Math.Cos(Theta)), CSng(radius * Math.Sin(Theta))) + centre
                SpriteBatch.Draw(dotTexture, PointToDraw, Color.White)
                Theta += ThetaStep
            End While
        End Sub


    End Class


